/////////////////////////////////////////////////////////////////////
// Class Creator Version 2.0.000 Copyrigth (C) Poul A. Costinsky 1994
///////////////////////////////////////////////////////////////////
// Header File FixedArray.h
// class CWizFixedArray
// class of array of any type of elements with fixed maximum size.
// Warning! RemoveAll DOESN'T call the destructor!!!!!
//
// 09/06/1996 16:57                             Author: Poul
///////////////////////////////////////////////////////////////////

#ifndef __CWizFixedArray_H
#define __CWizFixedArray_H

/////////////////////////////////////////////////////////////////////////////
// Helper class CWizFixedArrayAssigment
template<class TYPE>
class CWizFixedArrayAssigment
	{
	public:
		CWizFixedArrayAssigment(const TYPE* p, int n)
			: m_p(p), m_n (n) {}
	const TYPE*	m_p;
	const int	m_n;
	};
/////////////////////////////////////////////////////////////////////////////
// class CWizFixedArray
template<class TYPE, int MAX_SIZE>
class CWizFixedArray
{
public:
	struct XOverflow {}; // Works like ASSERT. Rare case when must be catched
// Constructors:
	// Default constructor
	CWizFixedArray () : m_nRealSize (0) {}
	// Copy constructor
	CWizFixedArray (const CWizFixedArray& T)
		: m_nRealSize (T.m_nRealSize)
		{
		for (INDEX i = 0; i < m_nRealSize; i++)
			m_Data[i] = T.m_Data [i];
		}
	// Psewdo-copy constructor: creates from Array with different MAX_SIZE
	CWizFixedArray (const CWizFixedArrayAssigment<TYPE>& at)
		: m_nRealSize (at.m_n)
		{
		if (at.m_n > MAX_SIZE) 
			throw XOverflow();
		m_nRealSize  = at.m_n;
		for (INDEX i = 0; i < m_nRealSize; i++)
			m_Data[i] = at.m_p[i];
		}
// Destructor:
	~CWizFixedArray () {}
public:
	// Copy operator
	CWizFixedArray& operator=(const CWizFixedArray& T)
		{
		m_nRealSize  = T.m_nRealSize;
		for (INDEX i = 0; i < m_nRealSize; i++)
			m_Data[i] = T.m_Data [i];
		return *this;
		}
	// Psewdo-copy operator: creates from Array with different MAX_SIZE
	CWizFixedArray& operator=(const CWizFixedArrayAssigment<TYPE>& at)
		{
		if (at.m_n > MAX_SIZE) 
			throw XOverflow();
		m_nRealSize  = at.m_n;
		for (INDEX i = 0; i < m_nRealSize; i++)
			m_Data[i] = at.m_p[i];
		return *this;
		}
// Operations:
	// Element access
	TYPE&		operator[] (int i)		 { ASSERT(i >= 0 && i < m_nRealSize); return m_Data[i]; }
	const TYPE& operator[] (int i) const { ASSERT(i >= 0 && i < m_nRealSize); return m_Data[i]; }
	TYPE&		ElementAt  (int i)		 { ASSERT(i >= 0 && i < m_nRealSize); return m_Data[i]; }
	const TYPE& GetAt      (int i) const { ASSERT(i >= 0 && i < m_nRealSize); return m_Data[i]; }
	// Size
	int		GetSize() const				 { return m_nRealSize; }
	// Adding elements
	int		Add(const TYPE& t) 
		{
		if (m_nRealSize >= MAX_SIZE)
			throw XOverflow();
		m_Data [m_nRealSize] = t;
		return m_nRealSize++;
		}
	// Cleaning. Again, DOESN'T call destructors of elements!
	void RemoveAll() { m_nRealSize = 0; }
	// Operator for creating object for psewdo-assigment
	operator const CWizFixedArrayAssigment<TYPE> () const
		{ return CWizFixedArrayAssigment<TYPE> (m_Data, m_nRealSize); }
protected:
// Implementation:
protected:
// Members:
	TYPE	m_Data [MAX_SIZE];
	int		m_nRealSize;
};


/////////////////////////////////////////////////////////////////////////////
#endif // __CWizFixedArray_H


